/**********************************************************************
  PPClCeBuR}h V~[^
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_scemu.h"

#ifdef SUPPORT_GRAPHIC_DEVICE
#include "sim_io.h"
int Thread_ID ;
int WINAPI gdev_thread(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) ;
#endif

#define	VERSION		"Ver 0.73 1999-2001"
#ifdef __human__
#define	PRATFORM	"X68k"
#else
#ifdef __CYGWIN__
#define	PRATFORM	"Cygwin"
#else
#define	PRATFORM	"AnyHost"
#endif
#endif

#define	FNAME_LENG	1024
#define	FILE_NUM	64

#define	PROC0_MEMSIZE_DEFAULT  0x10000	

void manprint() ;

int           i,j ;
unsigned char *workp ;
unsigned char infname[FILE_NUM][FNAME_LENG] ;
int           file_num ;

int main(int argc,char *argv[])
{
int res ; 

 file_num=0 ;
 simlog=NULL ;
 x_path = get_xpath( argv[0] ) ;
#ifdef SUPPORT_GRAPHIC_DEVICE
 GdevBuf.n=GdevAccessBufSize ;
#endif 
 for( i=1 ; i<argc ; i++ ){
   workp = argv[i] ;
   if( *workp == '-' ) {
     workp++ ;
     switch( *workp ){
     case 'h' :
     case 'H' :
     case '?' :
       manprint() ;
       exit(0) ;
       break ;
     case 'o' :
       i++ ;
       if( argc==i ) break ;
       j=strlen(argv[i]+1) ;
       simlog=malloc(j+1) ;
       strcpy(simlog,argv[i]) ;
       break ;
#ifdef SUPPORT_GRAPHIC_DEVICE
     case 'b' :
       i++ ;
       if( argc==i ) break ;
       GdevBuf.n=exatoi(argv[i]) ;
       break ;
#endif 
     }
   }else{
     workp = infname[file_num] ;
     for( j=0 ; j < FNAME_LENG ; j++ ) *workp++ = '\0' ; /*  */
     strcpy( infname[file_num++] , argv[i] ) ;
     if( file_num==FILE_NUM ){
       fprintf(stderr,"wt@Cő吔(=%d)𒴂܂\n",FILE_NUM) ;
       break ;
     }
   }
 }
 //setmode( fileno(stdout),O_BINARY ) ;
 
 default_memsize          = DEFAULT_MEMSIZE ;
 default_heaptop          = DEFAULT_HEAPTOP ;
 default_exec_start       = DEFAULT_EXEC_START ;
 default_stack_top_offset = DEFAULT_STACK_TOP_OFFSET ;

 init_sighandl_ppcsim() ;
 init_excp() ;
 init_sim_io() ;

 proc_list.cur_id=-1 ;
 for( i=0 ; i<MAX_PROCESS_ID ; i++ ){
   proc_list.proc[i].mem[0x0]=NULL ;
   proc_list.proc[i].mem_size[0x0]=0 ;
 }
 res=create_proc( &proc_list, 0x10000 ) ; /*** pid=0 𐶐 ***/
 if( res!=NORMAL_EXIT ){
   fprintf(stderr,"sĂ܂\n") ;
   exit(0) ;
 }
 trace_history=malloc( HISTORY_SIZE*sizeof(struct TRACE_HIST_STRUCT) ) ;
 trace_ptr=0 ;
 if( trace_history==NULL ){
   fprintf(stderr,"sĂ܂\n") ;
   exit(0) ;
 }
 for( i=0 ; i<HISTORY_SIZE ; i++ ){
   trace_history[i].pc  =0xffffffff ;
   trace_history[i].inst=0x00000000 ;
 }
 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   dir_list[i].ppc_mem_ptr=0 ;
   dir_list[i].cygwin_DIR =NULL ;
 }
 iexe_count =  0 ;
 iexe_count2=  0 ;
 pp_msg     =PP_DUMP_PC ;
 truss_stat =OFF ;
 prof_stat  =OFF ;
 trace_stat =TRACE_OFF ;
 verbose    =OFF ;
 for( i=0 ; i<MAX_PROCESS_ID ; i++ ){
   proc_list.proc[i].bp_num    = 0 ;
   proc_list.proc[i].pp_num    = 0 ;
   proc_list.proc[i].break_inum=-1 ;
 }

 if( simlog==NULL ){
   simmsgfp=DEFAULT_SIMMSG_OUT ;
 }else{
   simmsgfp=fopen( simlog,"wb" ) ;
   if( simmsgfp==NULL ){
     fprintf(stderr,"V~[VO(%s)I[vł܂ł\n",simlog ) ;
     exit(0) ;
   }
 }
 
#ifdef SUPPORT_GRAPHIC_DEVICE
 /** start gdev thread **/
 gd=NULL ;
 CreateThread(NULL,
 	      0,
 	      (LPTHREAD_START_ROUTINE)gdev_thread,
 	      0,
 	      0,
 	      (PDWORD)&Thread_ID) ;
 /** wait for gdev thread ready **/
 while(gd==NULL){
   char nul[1]={'\0'} ;
   printf("%s",nul) ;
 }
#endif

 /*** shellN ***/
 if( file_num == 0 ){
   cmd_exec( "-\0" ) ;	/*** C^NeBu[h ***/
 }else{
   for( i=0 ; i<file_num ; i++ ){
     cmd_exec( infname[i] ) ;
   }
 }
 exit(0) ;
}

#ifdef SUPPORT_GRAPHIC_DEVICE
int WINAPI gdev_thread (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
 MSG lpMsg;

 gd=OpenGdev(GRAPHIC_SCREEN_WIDTH, GRAPHIC_SCREEN_HEIGHT,GRAPHIC_NAME) ;
 if( gd==NULL ){
   fprintf(stderr,"OtBbNfoCX̃I[vɎs܂\n") ;
   exit(-1) ;
 }
 FlushBuffer(gd) ;

 while (GetMessage(&lpMsg, NULL, 0, 0)) {
   TranslateMessage(&lpMsg);
   DispatchMessage(&lpMsg);
 }
 return(0) ;
}
#endif

void manprint()
{
  printf("PPC Simulator for " PRATFORM " " VERSION " TANE\n");
  printf("Usage: ppcsim [-Options] [file....]\n");
  printf("  Options\n") ;
  printf("    -o log : V~[VbZ[Wt@Cɏo͂܂(default=stderr)\n");
#ifdef SUPPORT_GRAPHIC_DEVICE
  printf("    -b num : `obt@TCYw肵܂\n");
#endif
  printf("    -h,?   : wv\\܂\n");
  printf("\n") ;
  printf("  filew肵Ȃꍇ̓C^NeBuVF[hɂȂ܂B\n") ;
}
