/**********************************************************************
  ߎs ̂T
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int	op_exec5( struct MACHINE_RESOURCE *mres )
{
register unsigned int inst ;
unsigned int	fd,fa,fb,fc ;
unsigned int	rd ;

 inst=mres->inst ;

 fd=(inst & 0x03e00000)>>21 ;
 fa=(inst & 0x001f0000)>>16 ;
 fb=(inst & 0x0000f800)>>11 ;
 fc=(inst & 0x000007c0)>>6  ;
 rd=(inst & 0x00000001)     ;
 if( rd!=0 ) return(NOT_IMPLEMENTED_OP) ;
 
 switch( inst & 0x0000001e ){
   unsigned int *fpr_u ;
 case 0x00000004 : //fdivsx
   mres->FPR[fd].f=(float)mres->FPR[fa].f / (float)mres->FPR[fb].f ;
   break ;
 case 0x00000008 : //fsubsx
   mres->FPR[fd].f=(float)mres->FPR[fa].f - (float)mres->FPR[fb].f ;
   break ;
 case 0x0000000a : //faddsx
   mres->FPR[fd].f=(float)mres->FPR[fa].f + (float)mres->FPR[fb].f ;
   break ;
 case 0x00000010 : //fresx
   if( (float)mres->FPR[fb].f==0.0 ){ /**FPSCR[VE],FPSCR[ZE]̏ԂlȂĂ͂ȂȂ**/
     return(DIVIDED_BY_ZERO) ;
   }
   mres->FPR[fd].f=1.0/(float)mres->FPR[fb].f ;
   break ;
 case 0x00000012 : //fmulsx
   mres->FPR[fd].f=(float)mres->FPR[fa].f * (float)mres->FPR[fc].f ;
   break ;
 case 0x00000018 : //fmsubsx
   mres->FPR[fd].f=((float)mres->FPR[fa].f * (float)mres->FPR[fc].f) - (float)mres->FPR[fb].f ;
   break ;
 case 0x0000001a : //fmaddsx
   mres->FPR[fd].f=((float)mres->FPR[fa].f * (float)mres->FPR[fc].f) + (float)mres->FPR[fb].f ;
   break ;
 case 0x0000001c : //fnmsubsx
   mres->FPR[fd].f=((float)mres->FPR[fa].f * (float)mres->FPR[fc].f) - (float)mres->FPR[fb].f ;
   fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef LITTLE_ENDIAN
   fpr_u = fpr_u+1 ;
   *fpr_u= *fpr_u ^ 0x80000000 ;
#else
   *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
   break ;
 case 0x0000001e : //fnmaddsx
   mres->FPR[fd].f=((float)mres->FPR[fa].f * (float)mres->FPR[fc].f) + (float)mres->FPR[fb].f ;
   fpr_u = (unsigned int *)&mres->FPR[fd].f ;
#ifdef LITTLE_ENDIAN
   fpr_u = fpr_u+1 ;
   *fpr_u= *fpr_u ^ 0x80000000 ;
#else
   *fpr_u= *fpr_u ^ 0x80000000 ;
#endif
   break ;
 default :
   return(UNKNOWN_INSTRUCTION) ;
 }
 mres->pc += 4 ;
 return(0) ;
}
